﻿@using LoyaltyPointEngine.Model.Object.Member

@{
    string search = ViewBag.Search,
        orderColumn = ViewBag.OrderColumn,
        orderDirection = ViewBag.OrderDirection;

    int currentPage = ViewBag.CurrentPage,
        totalPage = ViewBag.TotalPage,
        paginationShowRange = 5;

}
@model List<MemberGridModel>

@*@Html.Grid(Model).Named("GridSelectMember").Columns(columns =>
     {
         columns.Add(x => x.Gender)
             .Titled("Gender")
             .Encoded(false)
             .Sanitized(false)
             .Sortable(true)
             .RenderValueAs(x => CustomRenderingOfGender(x.Gender)).Filterable(true);

         columns.Add(x => x.FirstName)
             .Titled("FirstName")
             .Encoded(false)
             .Sanitized(false)
             .Sortable(true)
             .RenderValueAs(x => x.FirstName).Filterable(true);

         columns.Add(x => x.LastName)
            .Titled("LastName")
            .Encoded(false)
            .Sanitized(false)
            .Sortable(true)
            .RenderValueAs(x => x.LastName).Filterable(true);

         columns.Add(x => x.Email)
            .Titled("Email")
            .Encoded(false)
            .Sanitized(false)
            .Sortable(true)
            .RenderValueAs(x => x.Email).Filterable(true);

         columns.Add(x => x.Phone)
            .Titled("Phone")
            .Encoded(false)
            .Sanitized(false)
            .Sortable(true)
            .RenderValueAs(x => x.Phone).Filterable(true);


         columns.Add(x => x.CreatedDate)
             .Titled("Created Date")
             .Encoded(false)
             .Sanitized(false)
             .Sortable(true)
             .RenderValueAs(x => x.CreatedDate.HasValue ? x.CreatedDate.Value.ToString("dd-MM-yyyy HH:mm") : string.Empty);

         columns.Add()
             .Encoded(false)
             .Sanitized(false)
             .SetWidth(50)
             .Css("cell-center")
         .RenderValueAs(x => string.Format("<a href=\"{0}\" onclick=\"SelectMember({1},'{2}')\" class=\"btn btn-xs btn-info\">Select</a>", "#", x.ID, x.FirstName.Trim()));

     }).Filterable()
    .Sortable()
    .WithPaging(5)*@

<div>
    <form name="grid-select-member-form">
        <input type="text" id="txtSearch" name="txtSearch" value="@search" class="form-control box-search" placeholder="Search for...">
        <input type="hidden" id="rawDataUrl" name="rawDataUrl" value="@GenerateUrl("@search@", orderColumn, orderColumn, orderDirection, 0)" />
    </form>
</div>
<div id="grid-select-member" data-lang="en">
    <div class="grid-wrap">
        <table class="table table-striped grid-table">
            <thead>
                <tr>
                    <th class="grid-header" title="Gender">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "Gender", orderColumn, orderDirection, 0)">Gender</a>
                        </div>
                    </th>
                    <th class="grid-header" title="FirstName">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "FirstName", orderColumn, orderDirection, 0)">FirstName</a>
                        </div>
                    </th>
                    <th class="grid-header" title="LastName">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "LastName", orderColumn, orderDirection, 0)">LastName</a>
                        </div>
                    </th>
                    <th class="grid-header" title="Email">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "Email", orderColumn, orderDirection, 0)">Email</a>
                        </div>
                    </th>
                    <th class="grid-header" title="Phone">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "Phone", orderColumn, orderDirection, 0)">Phone</a>
                        </div>
                    </th>
                    <th class="grid-header" title="Created Date">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "CreatedDate", orderColumn, orderDirection, 0)">Created Date</a>
                        </div>
                    </th>
                    <th class="grid-header" title="Channel">
                        <div class="grid-header-title">
                            <a data-url="@GenerateUrl(search, "Channel", orderColumn, orderDirection, 0)">Channel</a>
                        </div>
                    </th>
                    <th class="grid-header cell-center" style="width:50px;" title=""><div class="grid-header-title"><span></span></div></th>
                </tr>
            </thead>
            <tbody>
                @if (Model != null)
                {
                    foreach (MemberGridModel member in Model)
                    {
                        <tr class="grid-row ">
                            <td class="grid-cell" data-name="Gender">
                                <span>@member.Gender</span>
                            </td>
                            <td class="grid-cell" data-name="FirstName">@member.FirstName</td>
                            <td class="grid-cell" data-name="LastName">@member.LastName</td>
                            <td class="grid-cell" data-name="Email">@member.Email</td>
                            <td class="grid-cell" data-name="Phone">@member.Phone</td>
                            <td class="grid-cell" data-name="CreatedDate">@(member.CreatedDate.HasValue ? member.CreatedDate.Value.ToString("dd-MM-yyyy hh:mm") : "")</td>
                            <td class="grid-cell" data-name="Channel">@member.Channel</td>
                            <td class="grid-cell cell-center" data-name=""><a href="#" onclick="SelectMember(@member.ID,'@member.FirstName.Replace(System.Environment.NewLine," ").Trim()')" class="btn btn-xs btn-info">Select</a></td>
                        </tr>
                    }
                }
                else
                {
                    <tr class="grid-row ">
                        <td class="grid-cell" data-name="Gender">
                            <span></span>
                        </td>
                        <td class="grid-cell" data-name="FirstName"></td>
                        <td class="grid-cell" data-name="LastName"></td>
                        <td class="grid-cell" data-name="Email"></td>
                        <td class="grid-cell" data-name="Phone"></td>
                        <td class="grid-cell" data-name="CreatedDate"></td>
                        <td class="grid-cell" data-name="Channel"></td>
                        @*<td class="grid-cell cell-center" data-name=""><a href="#" onclick="SelectMember(@member.ID,'@member.FirstName.Replace(System.Environment.NewLine," ").Trim()')" class="btn btn-xs btn-info">Select</a></td>*@
                    </tr>
                }
            </tbody>
        </table>
        @if (totalPage > 1)
        {
            int startPage = currentPage - paginationShowRange > 1 ? currentPage - paginationShowRange : 1,
                endPage = currentPage + paginationShowRange < totalPage ? currentPage + paginationShowRange : totalPage;
            <div class="grid-footer">
                <div class="grid-footer">
                    <div class="grid-pager">
                        <ul class="pagination">
                            <li>
                                <a data-url="@GenerateUrl(search, orderColumn, orderColumn, orderDirection, currentPage <= 1 ? currentPage: currentPage -1, true)" class="grid-prev-page" title="Previous Page" style="">
                                    <span class="glyphicon glyphicon-step-backward"></span>
                                </a>
                            </li>
                            @for (var _page = startPage; _page <= endPage; _page++)
                            {
                                @*<li><a href="#" class="grid-pageSetLink prev" style="display: none;" data-pageset="1" data-partitionsize="5">...</a></li>*@
                                <li class="@(currentPage == _page ? "active": "")">
                                    <a data-url="@GenerateUrl(search, orderColumn, orderColumn, orderDirection, _page, true)" class="grid-page-link">
                                        @_page
                                    </a>
                                </li>
                            }
                            <li>
                                <a class="grid-page-link">
                                    @totalPage
                                </a>
                            </li>
                            <li>
                                <a data-url="@GenerateUrl(search, orderColumn, orderColumn, orderDirection, currentPage >= endPage ? endPage : currentPage + 1, true)" title="Next Page" class="grid-next-page">
                                    <span class="glyphicon glyphicon-step-forward"></span>
                                </a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        }
    </div>
</div>

@helper CustomRenderingOfGender(string strG)
{
    if (strG.ToLower() == "m")
    {
        <span>Male</span>
    }
    else if (strG.ToLower() == "f")
    {
        <span>Female</span>
    }
}

@functions {
    public string GetOrderDirectionByColumn(string currentCol, string currentDirection, string targetColumn, bool isPaging)
    {
        if (isPaging) return currentDirection;

        if (currentCol.ToLower() == targetColumn.ToLower())
        {
            if (currentDirection.ToLower() == "asc") return "desc";
            else return "asc";
        }
        return currentDirection;
    }

    public string GenerateUrl(string search, string targetColumn, string orderColumn, string orderDirection, int? page, bool isPaging = false)
    {
        return Url.Action(MVC.Member.GridGetSelectMemberPager(search, targetColumn, GetOrderDirectionByColumn(orderColumn, orderDirection, targetColumn, isPaging), page));
    }
}